#!/usr/bin/env ruby -w
#---
# Excerpted from "TextMate",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/textmate for more book information.
#---

$LOAD_PATH << "#{ENV["TM_SUPPORT_PATH"]}/lib"
require "exit_codes"
require "web_preview"
require "escape"

check = `ruby -c 2>&1`

if check.include? "Syntax OK"
  puts check
else
  file = ENV["TM_FILEPATH"]
  check = htmlize(check)
  check.gsub!( /(^|<br>)-:(\d+):\s+([\w\s]+)/,
               "\\1<a href='txmt://open?url=file://#{file}&line=\\2'>\\3</a>" )
  html_header("Syntax Checker", "Ruby")
  puts <<END_HTML
<h1>Errors Located in Your File</h1>
<pre style="white-space: normal;">#{check}</pre>
END_HTML
  html_footer
  TextMate.exit_show_html
end
